<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

// Titre : on récupère celui de la première page
$mysqli = connectsql();
$resultat = $mysqli->query('SELECT titre FROM pages WHERE id = 1');
$r = $resultat->fetch_assoc();
$resultat->free();
$titre = "${r['titre']}";

/////////////////////////////////////////////////////////////////////
// Gestion de la demande : oubli d'identifiant, création de compte //
/////////////////////////////////////////////////////////////////////

// Oubli d'identifiant
if ( isset($_REQUEST['oublimdp']) && isset($_REQUEST['mail']) && strlen($mail = $_REQUEST['mail']) )  {

  // Recherche de l'adresse électronique dans la base de données
  $resultat = $mysqli->query('SELECT id, login, mail, mdp FROM utilisateurs WHERE LENGTH(mail)');
  while ( $r = $resultat->fetch_assoc() )
    if ( $r['mail'] == $mail )  {
      $utilisateur = $r;
      break;
    }
  $resultat->free();
  if ( !isset($utilisateur) )  {
    $mysqli->close();
    exit('{"etat":"nok_","message":"L\'adresse électronique donnée est inconnue. Si vous venez de demander la création de votre compte, le mot de passe n\'est pas modifiable tant que les professeurs de la classe n\'ont pas validé l\'inscription. Vous recevrez un courriel quand cela sera effectif.<p class=\"warning\"><a href=\".\">Retourner au Cahier de Prépa</a></p>"}');
  }

  // Retour de courriel : variable $_REQUEST['p'] 
  if ( isset($_REQUEST['p']) )  {
    // Si variable $_REQUEST['p'] à une mauvaise valeur, on l'efface : le
    // formulaire affiché sera celui de demande d'adresse électronique
    if ( ( $_REQUEST['p'] != sha1($site.date('Y-m-d-H').$utilisateur['mdp']) ) && ( $_REQUEST['p'] != sha1($site.date('Y-m-d-H',time()+900).$utilisateur['mdp']) ) )
      unset($_REQUEST['p']);

    // Traitement du formulaire
    elseif ( isset($_REQUEST['mdp1']) && strlen($newmdp = $_REQUEST['mdp1']) )  {
      if ( $newmdp != $_REQUEST['mdp2'] )  {
        $mysqli->close();
        exit('{"etat":"nok_","message":"Les deux mots de passe donnés ne sont pas identiques."}');
      }
      // Écriture du nouveau mot de passe
      $mysqli->close();
      $mysqli = connectsql(true);
      $message = ( requete('utilisateurs',"UPDATE utilisateurs SET mdp = '".sha1($newmdp)."' WHERE id = ${utilisateur['id']}",$mysqli) ) ? '{"etat":"ok_","message":"Votre mot de passe a bien été modifié.</p><p class=\"warning\"><a href=\".\">Retourner au Cahier de Prépa</a></p>"}' : '{"etat":"nok_","message":"Votre mot de passe n\'a pas pu être modifié suite à une erreur technique."}';
      $mysqli->close();
      exit($message);
    }
  }

  // Envoi de courriel
  else  {
    // On ajoute 15 minutes au temps utilisé :
    // de xh00 à xh45, on a jusqu'à (x+1)h, de xh45 à (x+1)h on a jusqu'à (x+2)h
    $t = time() + 900;
    $lien = ( $https ? 'https' : 'http' )."://$site/connexion?oublimdp&mail=$mail&p=".sha1($site.date('Y-m-d-H',$t).$utilisateur['mdp']);
    $s = strstr($site.'/','/',true);
    if ( !isset($mailadmin) )  $mailadmin = 'admin@cahier-de-prepa.fr';
    mail($mail,'=?UTF-8?B?'.base64_encode('[Cahier de Prépa] Changement de mot de passe').'?=',
'Bonjour

Vous avez rempli une demande de modification de votre mot de passe sur le Cahier de Prépa <http'.($https?'s':'')."://$site>, correspondant à l'identifiant ${utilisateur['login']}.

Si cette demande ne vient pas de vous ou si vous avez retrouvé votre mot de passe, merci d'ignorer simplement ce courriel.

Sinon, veuillez cliquer ci-dessous pour vous rendre à la page qui vous permettra de modifier votre mot de passe :
    $lien
Ce lien est valable jusqu'à ".date('G\h00',$t+3600).'.

Cordialement,
-- 
Cahier de Prépa
','From: =?UTF-8?B?'.base64_encode('Cahier de Prépa')."?= <$mailadmin>\r\nContent-type: text/plain; charset=UTF-8","-f$mailadmin");
    $mysqli->close();
    exit('{"etat":"ok_","message":"Un courriel vient de vous être envoyé à l\'adresse <code>'.$mail.'</code>.<br>Si vous ne voyez rien, pensez à regarder dans les courriels marqués comme spam. Certains serveurs retardent jusqu\'à 10 minutes l\'arrivée des messages, normalement la première fois uniquement.<br>Le courriel qui vous a été envoyé contiendra un lien, valable jusqu\'à '.date('G\h00',$t+3600).', vous permettant de modifier votre mot de passe.<p class=\"warning\"><a href=\".\">Retourner au Cahier de Prépa</a></p>"}');
  }
}

// Création de compte
elseif ( isset($_REQUEST['creationcompte']) )  {
  
  // Vérification de la possibilité de rajouter des comptes
  // Si un utilisateur au mot de passe vide a été inséré, c'est le réglage pour
  // arrêter la création de compte
  $resultat = $mysqli->query('SELECT id FROM utilisateurs WHERE LENGTH(mdp) = 0');
  if ( $creationinterdite = $resultat->num_rows )
    $resultat->free();
  elseif ( isset($_REQUEST['mail']) && strlen($mail = strtolower(trim($_REQUEST['mail']))) )  {
    // Vérifications
    if ( !filter_var($mail,FILTER_VALIDATE_EMAIL) )  {
      $mysqli->close();
      exit('{"etat":"nok_","message":"L\'adresse saisie n\'est pas une adresse électronique valide.<br>Vous avez dû faire une faute de frappe."}');
    }
    if ( in_array($domaine = strstr($mail,'@'),array('@gmail.fr','@laposte.fr')) )  {
      $mysqli->close();
      exit('{"etat":"nok_","message":"L\'adresse saisie ne pourra pas fonctionner&nbsp;: le domaine <code>'.$domaine.'</code> ne reçoit pas de courriels."}');
    }
    // Recherche du mail dans la base de données
    $resultat = $mysqli->query('SELECT GROUP_CONCAT(mail) AS mails FROM utilisateurs WHERE LENGTH(mail)');
    $r = $resultat->fetch_assoc();
    $resultat->free();
    if ( in_array($mail,$mails = explode(',',$r['mails'])) || in_array("@$mail",$mails) )  {
      $mysqli->close();
      exit('{"etat":"nok_","message":"Un compte avec cette adresse électronique existe déjà. Si vous venez de demander la création de votre compte, le compte n\'est pas modifiable tant que les professeurs de la classe n\'ont pas validé l\'inscription. Vous recevrez un courriel quand cela sera effectif. Si ce compte a déjà été validé par les professeurs, vous pouvez <a href=\"?oublimdp\">changer le mot de passe</a>.<p class=\"warning\"><a href=\".\">Retourner au Cahier de Prépa</a></p>"}');
    }

    // Retour de mail : variable $_REQUEST['p'] 
    if ( isset($_REQUEST['p']) )  {
      // Si variable $_REQUEST['p'] à une mauvaise valeur, on l'efface : le
      // formulaire affiché sera celui de demande d'adresse mail
      if ( ( $_REQUEST['p'] != sha1($site.$mdp.date('Y-m-d-H').$mail) ) && ( $_REQUEST['p'] != sha1($site.$mdp.date('Y-m-d-H',time()+900).$mail) ) )
        unset($_REQUEST['p']);

      // Traitement du formulaire
      // Un compte temporaire non validé par l'équipe pédagogique contient une
      // adresse mail commençant par @ (pour interdire le changement de mdp)
      // et un mot de passe commençant par * (pour interdire la connexion).
      elseif ( isset($_REQUEST['nom']) )  {
        if ( !strlen($nom = trim($_REQUEST['nom'])) )
          $message = '{"etat":"nok_","message":"Le nom est obligatoire."}';
        elseif ( !isset($_REQUEST['prenom']) || !strlen($prenom = trim($_REQUEST['prenom'])) )
          $message = '{"etat":"nok_","message":"Le prénom est obligatoire."}';
        elseif ( !isset($_REQUEST['mdp1']) || !strlen($newmdp = $_REQUEST['mdp1']) )
          $message = '{"etat":"nok_","message":"Le mot de passe est obligatoire."}';
        elseif ( $newmdp != $_REQUEST['mdp2'] )
          $message = '{"etat":"nok_","message":"Les deux mots de passe donnés ne sont pas identiques."}';
        else  {
          // Nettoyage des données envoyées
          $prenom = mb_convert_case(strip_tags($mysqli->real_escape_string($prenom)),MB_CASE_TITLE,'UTF-8');
          $nom = mb_convert_case(strip_tags($mysqli->real_escape_string($nom)),MB_CASE_TITLE,'UTF-8');
          $mail = $mysqli->real_escape_string($mail);
          $newmdp = sha1($newmdp);
          // Login automatique
          $login = mb_strtolower(mb_substr($prenom,0,1,'UTF-8').str_replace(' ','_',$nom),'UTF-8');
          $resultat = $mysqli->query('SELECT GROUP_CONCAT(login) AS logins FROM utilisateurs');
          $r = $resultat->fetch_assoc();
          $resultat->free();
          if ( in_array($login,explode(',',$r['logins'])) )
            $message = '{"etat":"nok_","message":"Un compte avec le même identifiant existe déjà. Merci de vous connecter avec l\'adresse électronique correspondante."}';
          else  {
            // Récupération des matières
            $resultat = $mysqli->query('SELECT GROUP_CONCAT(id) AS matieres FROM matieres');
            $r = $resultat->fetch_row();
            $resultat->free();
            // Si "colleur" choisi, autorisation vaut 3. Sinon, 2 (élève)
            if ( $_REQUEST['autorisation'] == 2 )  {
              $autorisation = 3;
              // Vérification de la matière
              $matiere = ( isset($_REQUEST['matiere']) && in_array($_REQUEST['matiere'],explode(',',$r['0'])) ) ? "0,${_REQUEST['matiere']}" : 0;
              $mailexp = "$prenom $nom";
              $mailcopy = 1;
            }
            else  {
              $autorisation = 2;
              // De base : toutes matières
              $matiere = "0,${r[0]}";
              $mailexp = '';
              $mailcopy = 0;
            }
            // Écriture du nouveau compte
            $mysqli->close();
            $mysqli = connectsql(true);
            $message = ( requete('utilisateurs',"INSERT INTO utilisateurs SET login = '$login', prenom = '$prenom', nom = '$nom', mail = '@$mail',
                       mdp = '*$newmdp', autorisation = $autorisation, matieres = '$matiere', timeout = 900, mailexp = '$mailexp', mailcopy = $mailcopy",$mysqli) )
                       ? '{"etat":"ok_","message":"Votre demande d\'inscription est terminée. Elle est maintenant en attente de validation par les professeurs de la classe. Vous recevrez un courriel lorsque votre inscription sera validée.</p><p class=\"warning\"><a href=\".\">Retourner au Cahier de Prépa</a></p>"}'
                       : '{"etat":"nok_","message":"Votre demande d\'inscription n\'a pas pu être enregistrée suite à une erreur technique."}';
          }
        }
        $mysqli->close();
        exit($message);
      }
    }
    
    // Envoi de mail
    else  {
      // On ajoute 15 minutes au temps utilisé : de xh00 à xh45,
      // on a jusqu'à (x+1)h, de xh45 à (x+1)h on a jusqu'à (x+2)h
      $t = time() + 900;
      $lien = ( $https ? 'https' : 'http' )."://$site/connexion?creationcompte&mail=$mail&p=".sha1($site.$mdp.date('Y-m-d-H',$t).$mail);
      if ( !isset($mailadmin) )  $mailadmin = 'admin@cahier-de-prepa.fr';
      mail($mail,'=?UTF-8?B?'.base64_encode('[Cahier de Prépa] Création de compte').'?=',
'Bonjour

Vous venez de donner cette adresse pour une demande de création de compte sur le Cahier de Prépa <http'.($https?'s':'')."://$site>.

Si cette demande ne vient pas de vous, merci d'ignorer simplement ce courriel.

Sinon, veuillez cliquer ci-dessous pour vous rendre à la page qui vous permettra de terminer votre inscription :
   $lien
Ce lien est valable jusqu'à ".date('G\h00',$t+3600).'.

Cordialement,
-- 
Cahier de Prépa
','From: =?UTF-8?B?'.base64_encode('Cahier de Prépa')."?= <$mailadmin>\r\nContent-type: text/plain; charset=UTF-8","-f$mailadmin");
      $mysqli->close();
      exit('{"etat":"ok_","message":"Un courriel vient de vous être envoyé à l\'adresse <code>'.$mail.'</code>.<br>Si vous ne voyez rien, pensez à regarder dans les courriels marqués comme spam. Vérifiez bien qu\'il n\'y a pas d\'erreur dans cette adresse, car vous ne pourrez pas continuer votre inscription si elle est fausse. Certains serveurs retardent jusqu\'à 10 minutes l\'arrivée des messages, la première fois uniquement.<br>Le courriel qui vous a été envoyé contiendra un lien, valable jusqu\'à '.date('G\h00',$t+3600).', vous permettant de terminer votre inscription.<p class=\"warning\"><a href=\".\">Retourner au Cahier de Prépa</a></p>"}');
    }
  }
}

// Réponse à une invitation
elseif ( isset($_REQUEST['reponseinvitation']) && isset($_REQUEST['mail']) && strlen($mail = $_REQUEST['mail']) && isset($_REQUEST['p']) && ( $_REQUEST['p'] == sha1($site.$mdp.$mail) ) )  {
  // Recherche de l'adresse électronique dans la base de données
  $resultat = $mysqli->query('SELECT id, login, mail, LENGTH(mdp) AS lmdp FROM utilisateurs WHERE LENGTH(mail)');
  while ( $r = $resultat->fetch_assoc() )
    if ( $r['mail'] == $mail )  {
      $utilisateur = $r;
      break;
    }
  $resultat->free();
  if ( !isset($utilisateur) )  {
    debut($mysqli,$titre,'L\'adresse électronique donnée est inconnue. Le compte pour lequel vous avez été invité a peut-être été supprimé.',false);
    $mysqli->close();
    fin();
  }
  if ( $r['lmdp'] == 40 )  {
    debut($mysqli,$titre,'Le mot de passe a déjà été défini. Si vous souhaitez le modifier, vous pouvez utiliser le formulaire de <a href="?oublimdp">mot de passe oublié</a>.',false);
    $mysqli->close();
    fin();
  }
  
  // Modification du mot de passe
  if ( isset($_REQUEST['mdp1']) && strlen($newmdp = $_REQUEST['mdp1']) )  {
    if ( $newmdp != $_REQUEST['mdp2'] )  {
      $mysqli->close();
      exit('{"etat":"nok_","message":"Les deux mots de passe donnés ne sont pas identiques."}');
    }
    // Écriture du nouveau mot de passe
    $mysqli->close();
    $mysqli = connectsql(true);
    $message = ( requete('utilisateurs',"UPDATE utilisateurs SET mdp = '".sha1($newmdp)."' WHERE id = ${utilisateur['id']}",$mysqli) ) ? '{"etat":"ok_","message":"Votre mot de passe a bien été modifié.</p><p class=\"warning\"><a href=\".\">Retourner au Cahier de Prépa</a></p>"}' : '{"etat":"nok_","message":"Votre mot de passe n\'a pas pu être modifié suite à une erreur technique."}';
    $mysqli->close();
    exit($message);
  }
}

////////////
/// HTML ///
////////////
debut($mysqli,$titre,'',false);
if ( isset($_REQUEST['oublimdp']) )  {
  if ( !isset($_REQUEST['p']) )
    echo <<<FIN

  <article>
    <a class="icon-ok" title="Valider"></a>
    <form onsubmit="$('a.icon-ok').click(); return false;">
      <h3>Mot de passe oublié</h3>
      <p>Si vous avez oublié votre mot de passe, vous pouvez le récupérer en entrant votre adresse électronique ci-dessous. Vous recevrez un courriel contenant un lien temporaire permettant de modifier votre mot de passe.</p>
      <input class="ligne" type="text" name="mail" data-placeholder="Adresse électronique">
    </form>
  </article>

FIN;
  else
    echo <<<FIN

  <article>
    <a class="icon-ok" title="Valider"></a>
    <form>
      <h3>Mot de passe oublié</h3>
      <p>Veuillez entrer deux fois votre nouveau mot de passe&nbsp;:</p>
      <input class="ligne" type="password" name="mdp1" data-placeholder="Mot de passe">
      <input class="ligne" type="password" name="mdp2" data-placeholder="Confirmation">
      <input type="hidden" name="p" value="${_REQUEST['p']}">
      <input type="hidden" name="mail" value="${utilisateur['mail']}">
    </form>
  </article>

FIN;
?>

  <script type="text/javascript">
$( function() {
  // Placeholders
  $('input[data-placeholder]').placeholder();
  // Envoi
  $('a.icon-ok').on("click",function () {
    $.ajax({url: 'connexion.php', method: "post", data: 'oublimdp=&'+$('form').serialize(), dataType: 'json'})
    .done( function(data) {
      if ( data['etat'] == 'ok_' ) {
        $('p').html(data['message']).removeClass('warning');
        $('a.icon-ok, input').remove();
      }
      else if ( data['etat'] == 'nok_' )
        $('p').html(data['message']).addClass('warning');
    });
  });
  // Envoi par appui sur Entrée
  $('input[name!="mail"]').on('keypress',function (e) {
    if ( e.which == 13 )
      $('a.icon-ok').click();
  });
  // Focus avec du retard pour éviter un bug d'affichage du placeholder
  setTimeout(function() { $('input:first').focus() },500);
});
  </script>

<?php
}

elseif ( isset($_REQUEST['creationcompte']) )  {
  if ( $creationinterdite )
    echo '<h2>La demande de création de compte n\'est pas autorisée sur ce Cahier de Prépa.</h2><p style="text-align:center;"><a href=".">Retour à la page d\'accueil</a></p>';
  elseif ( !isset($_REQUEST['p']) )
    echo <<<FIN

  <article>
    <a class="icon-ok" title="Valider"></a>
    <form onsubmit="$('a.icon-ok').click(); return false;">
      <h3>Création de compte</h3>
      <p>Vous pouvez demander ici une création de compte sur ce Cahier de Prépa, si vous êtes élève ou colleur. Vous devez tout d'abord fournir une adresse électronique valide. Vous recevrez un courriel contenant un lien temporaire permettant de continuer votre inscription.</p>
      <p>Il est par ailleurs conseillé de consulter cette adresse régulièrement, puisque les professeurs et colleurs de la classe pourront vous envoyer des courriels sur cette adresse via Cahier de Prépa. Cette adresse ne sera divulguée à personne d'autre que les professeurs et colleurs de la classe.</p>
      <p>À la fin de votre inscription, la demande sera mise en attente de validation par les professeurs de la classe.</p>
      <input class="ligne" type="text" name="mail" data-placeholder="Adresse électronique">
    </form>
  </article>

FIN;
  else  {
    // Récupération des matières
    $resultat = $mysqli->query('SELECT id, nom FROM matieres');
    $select_matieres = '';
    while ( $r = $resultat->fetch_assoc() )
      $select_matieres .= "        <option value=\"${r['id']}\">${r['nom']}</option>\n";
    $resultat->free();
    echo <<<FIN

  <article>
    <a class="icon-ok" title="Valider"></a>
    <form>
      <h3>Création de compte</h3>
      <p>Vous pouvez demander ici une création de compte sur ce Cahier de Prépa, si vous êtes élève ou colleur. Une fois votre demande remplie, l'inscription sera mise en attente de validation par les professeurs de la classe. Vous recevrez un courriel si votre inscription est validée.</p>
      <p>Le mot de passe vous est complètement personnel et ne sera divulgué à personne. Il est chiffré avant son stockage dans la base de données. La bonne pratique est de ne pas écrire un simple mot du dictionnaire mais une suite de lettres, de chiffres et de signes de ponctuation qui n'ont de sens que pour vous. Tous les caractères de votre clavier, y compris l'espace, sont autorisés.</p>
      <input class="ligne" type="text" id="prenom" name="prenom" size="50" data-placeholder="Prénom">
      <input class="ligne" type="text" id="nom" name="nom" size="50"" data-placeholder="Nom">
      <input class="ligne" type="password" name="mdp1" data-placeholder="Mot de passe">
      <input class="ligne" type="password" name="mdp2" data-placeholder="Confirmation">
      <p class="ligne"><label for="autorisation">Élève ou colleur&nbsp;:</label>
        <select name="autorisation" id="autorisation">
          <option value="1">Élève</option>
          <option value="2">Colleur</option>
        </select>
      </p>
      <p class="ligne"><label for="matiere">Matière&nbsp;:</label>
        <select name="matiere" id="matiere">
$select_matieres
        </select>
      </p>
      <input type="hidden" name="p" value="${_REQUEST['p']}">
      <input type="hidden" name="mail" value="$mail">
    </form>
  </article>

FIN;
  }
?>

  <script type="text/javascript">
$( function() {
  // Placeholders
  $('input[data-placeholder]').placeholder();
  // Envoi
  $('a.icon-ok').on("click",function () {
    $.ajax({url: 'connexion.php', method: "post", data: 'creationcompte=&'+$('form').serialize(), dataType: 'json'})
    .done( function(data) {
      if ( data['etat'] == 'ok_' )  {
        $('p:first').html(data['message']).removeClass('warning');
        $('a.icon-ok, p+p, .ligne').remove();
      }
      else if ( data['etat'] == 'nok_' )  {
        $('p:first').html(data['message']).addClass('warning');
        $('p').not(':first').not('.ligne').remove();
      }
    });
  });
  // Envoi par appui sur Entrée
  $('input[name!="mail"],select').on('keypress',function (e) {
    if ( e.which == 13 )
      $('a.icon-ok').click();
  });
  // Focus avec du retard pour éviter un bug d'affichage du placeholder
  setTimeout(function() { $('input:first').focus() },500);
  // Pour la matière associée (colleurs seulement)
  $('#autorisation').on("change keyup", function() { 
    switch ( $(this).val() )  {
      case '1' : $('#matiere').parent().hide(); break;
      case '2' : $('#matiere').parent().show();
    }
  });
  $('#matiere').parent().hide();
});
  </script>

<?php
}

elseif ( isset($_REQUEST['reponseinvitation']) )  {
  if ( isset($utilisateur['login']) )  {
?>

  <article>
    <a class="icon-ok" title="Valider"></a>
    <form>
      <h3>Création de compte</h3>
      <p>L'équipe pédagogique vous a créé un compte ici. L'identifiant associé à ce compte est</p>
      <p class="warning"><?php echo $utilisateur['login']; ?></p>
      <p>Il ne vous reste plus qu'à définir votre mot de passe. Le mot de passe vous est complètement personnel et ne sera divulgué à personne. Il est chiffré avant son stockage dans la base de données. La bonne pratique est de ne pas écrire un simple mot du dictionnaire mais une suite de lettres, de chiffres et de signes de ponctuation qui n'ont de sens que pour vous. Tous les caractères de votre clavier, y compris l'espace, sont autorisés.</p>
      <input class="ligne" type="password" name="mdp1" data-placeholder="Mot de passe">
      <input class="ligne" type="password" name="mdp2" data-placeholder="Confirmation">
      <input type="hidden" name="p" value="<?php echo $_REQUEST['p']; ?>">
      <input type="hidden" name="mail" value="<?php echo $mail; ?>">
    </form>
  </article>
  
  <script type="text/javascript">
$( function() {
  // Placeholders
  $('input').placeholder();
  // Envoi
  $('a.icon-ok').on("click",function () {
    $.ajax({url: 'connexion.php', method: "post", data: 'reponseinvitation=&'+$('form').serialize(), dataType: 'json'})
    .done( function(data) {
      if ( data['etat'] == 'ok_' )  {
        $('form').html('<p>'+data['message']+'</p>');
      }
      else if ( data['etat'] == 'nok_' )  {
        $('p:first').html(data['message']).addClass('warning');
        $('p').not(':first').not('.ligne').remove();
      }
    });
  });
  // Envoi par appui sur Entrée
  $('input').on('keypress',function (e) {
    if ( e.which == 13 )
      $('a.icon-ok').click();
  });
  // Focus avec du retard pour éviter un bug d'affichage du placeholder
  setTimeout(function() { $('input:first').focus() },500);
});
  </script>
<?php
  }
  else
    echo '<h2>Les paramètres d\'accès à cette page ne sont pas corrects.</h2>';
}

else
  echo '<h2>Aucune action n\'a été effectuée.</h2>';

$mysqli->close();
fin();
?>
